AppTitle "Lamps"
Const xgraph=640,ygraph=480
SeedRnd MilliSecs()
Graphics xgraph,ygraph,16,1
HidePointer:TFormFilter 0

Global img_lamp=LoadAnimImage(".\data\lamp.bmp",50,100,0,2);MaskImage img_lamp,255,0,255
Global img_on=LoadAnimImage(".\data\on.bmp",50,25,0,2):MaskImage img_on,255,0,255
Global img_off=LoadAnimImage(".\data\off.bmp",50,25,0,2):MaskImage img_off,255,0,255
Global img_scale=LoadImage(".\data\scale.bmp"):MaskImage img_scale,255,0,255
Global img_mouse=LoadImage(".\data\hand.bmp"):MaskImage img_mouse,255,0,255
Global img_okbutton=LoadImage(".\data\ok.bmp"):MaskImage img_okbutton,255,0,255
ScaleImage img_scale,2.0,2.0
ScaleImage img_lamp,2.0,2.0
ScaleImage img_on,2.0,2.0
ScaleImage img_off,2.0,2.0

Global snd_click=LoadSound(".\data\click.wav")

Dim switch_anim_time(4):For i=0 To 4:switch_anim_time(i)=MilliSecs():Next
Dim switch_fizz_status(4):For i=0 To 4:switch_fizz_status(i)=True:Next
Dim switch_time(4):For i=0 To 4:switch_time(i)=MilliSecs():Next
Dim lamp.TLamp(4):For i=0 To 4:lamp.TLamp(i)=New TLamp:lamp(i)\on=False:Next

Global font1=LoadFont("arial",50)
Global font2=LoadFont("arial",20)

Global starttime=MilliSecs()

SetBuffer BackBuffer()
SetFont font2
Repeat
	Cls
	
	If MouseHit(1) Then MouseReaction(MouseX(),MouseY())
	ManipulateSwitches
	Manipulatelight
	
	DrawLamp
	AnimateSwitches
	DrawScale
	Drawguide()
	
	DrawImage img_mouse,MouseX(),MouseY()
	Flip
	If Countlights()=5 Then WinReaction()
Until KeyDown(1)

Type TLamp
	Field on
End Type

Function DrawLamp()
	For i=0 To 4
		DrawImage img_lamp,(100*i)+(i*5),ygraph-ImageHeight(img_lamp)-ImageHeight(img_on),Not lamp(i)\on
	Next
End Function 

Function  MouseReaction(x,y)
	For i=0 To 4
		If x > (100*i)+(i*5) And x < (((100*i)+(i*5))+66) And y > ygraph-ImageHeight(img_on) And y < ygraph Then
			If snd_click Then PlaySound snd_click
			lamp(i)\on=True
		EndIf
	Next
End Function

Function DrawScale()
	DrawImage img_scale,12,100
	lights=CountLights()
	Color 255,0,0
	Rect 14+(ImageWidth(img_scale)-10)/5*lights,105,2,ImageHeight(img_scale)-10
	
End Function

Function CountLights()
	lamps_on=0
	For i=0 To 4
		If lamp(i)\on Then lamps_on=lamps_on+1
	Next

	Return lamps_on
End Function

Function WinReaction()
	wintime=MilliSecs()
	score=(wintime-starttime)/1000
	ActualizeHighscore(score)
	hscore=GetHighscore()
	Repeat
		Cls
		
		DrawLamp
		AnimateSwitches
		DrawScale
		
		If KeyDown(1) Then End
		If MouseHit(1) Then
			If MouseX() > xgraph/2-ImageWidth(img_okbutton)/2 And MouseX() < (xgraph/2+ImageWidth(img_okbutton)/2) And MouseY() > 300 And MouseY() < (300+ImageHeight(img_okbutton)) Then
				Exit
			EndIf
		EndIf
		
		Color 80,80,80
		Rect 50,50,xgraph-100,ygraph-100
		
		Color 255,255,255
		SetFont font1
		Text xgraph/2,80,"Congratulations!",1
		
		SetFont font2
		Text xgraph/2,180,"You solved that in "+score+" seconds! A bit difficult, isn't it?",1
		If hscore=score Then
			Text xgraph/2,200,"You beat the Highscore!",1
		Else
			Text xgraph/2,200,"The shortest time someone had was "+hscore+"!",1
		EndIf
		Text xgraph/2,220,"Press 'OK' to play the game once again! 'ESC' to quit",1
		
		DrawImage img_okbutton,xgraph/2-ImageWidth(img_okbutton)/2,300
		
		DrawImage img_mouse,MouseX(),MouseY()
		Flip
	Forever
	For i=0 To 4
		lamp(i)\on=False
	Next
	starttime=MilliSecs()
	Return
End Function

Function ManipulateLight()
	lamps_on=CountLights()
	ClsColor 255/5*lamps_on,255/5*lamps_on,255/5*lamps_on
End Function

Function AnimateSwitches()
	For i=0 To 4
		If MilliSecs()-switch_anim_time(i)>Rand(300,500) Then switch_fizz_status(i)=Not switch_fizz_status(i)
		If lamp(i)\on Then
			DrawImage img_on,(100*i)+(i*5),ygraph-ImageHeight(img_on),switch_fizz_status(i)
		Else
			DrawImage img_off,(100*i)+(i*5),ygraph-ImageHeight(img_on),switch_fizz_status(i)
		EndIf
	Next
End Function

Function DrawGuide()
	Color 127,127,127
	Rect 520,0,xgraph-520,ygraph
	Color 255,255,255
	Text 530,10,"Time: "+(MilliSecs()-starttime)/1000+" sec"
	Text 530,40,"Instruction":Text 530,40,"_________"
	Text 530,60,"Your Objective"
	Text 530,80,"is to get all on."
	Text 530,100,"Unfortunately"
	Text 530,120,"they are very"
	Text 530,140,"old. Their"
	Text 530,160,"switches don't"
	Text 530,180,"work very well"
	Text 530,200,"and get very"
	Text 530,220,"fast off."
	Text 530,250,"Press 'ESC' to"
	Text 530,270,"exit the game."
End Function

Function GetHighscore()
	file=ReadFile(".\data\hs.sth")
	If file=0 Then Return 2147483647
	score=Int(ReadLine(file))
	CloseFile file
	Return score
End Function

Function ActualizeHighscore(score)
	highscore=GetHighscore()
	If score<highscore Then
		file=WriteFile(".\data\hs.sth")
		WriteLine file,score
		CloseFile file
	EndIf
End Function

Function ManipulateSwitches()
	For i=0 To 4
		If MilliSecs()-switch_time(i)>=Rand(1300,1750) Then 
			lamp(i)\on=False
			switch_time(i)=MilliSecs()
		EndIf
	Next
End Function







































